from PyQt5.QtCore import pyqtSignal, Qt
from PyQt5.QtCore import QSize
from PyQt5.Qt import Qt
from PyQt5.QtGui import QIcon, QPixmap
from PyQt5.QtWidgets import QPushButton, QLabel, QVBoxLayout, QWidget,QDialog
from PyQt5.uic.properties import QtGui
import sys
import icons_rc

from PyQt5 import QtCore, QtGui


class UserLabel(QLabel):
    clicked = pyqtSignal()

    def mouseReleaseEvent(self, QMouseEvent):
        if QMouseEvent.button() == Qt.LeftButton:
            self.clicked.emit()

class LoginWindow(QDialog):
    def __init__(self, parent=None):
        self.parent = parent
        super().__init__()

        self.btn_signOut = QPushButton("Çıkış")
        self.btn_signIn = QPushButton("Oturum Aç")
        self.btn_register = QPushButton("Kayıt Ol")
        self.lbl_img_user = QLabel()
        self.lbl_user_name_surname = QLabel(self.lbl_img_user)

        self.lbl_user_account = QLabel("Oturum açılmadı")
        self.retranslateUi(LoginWindow)
        self.setupUi(self)

        # geo = self.geometry()
        # geo.moveTopRight(self.parent.geometry().topRight() + QtCore.QPoint(0, 80))
        # self.setGeometry(geo)

        self.btn_signOut.clicked.connect(self.UserSignOutClick)
        self.btn_signIn.clicked.connect(self.UserSignInClick)
        self.btn_register.clicked.connect(self.UserRegisterClick)

    def UserSignInClick(self):
        self.lbl_user_name_surname.setText("MM")
        self.lbl_img_user.setPixmap(QPixmap(':/icon/images/user2.png'))

    def UserSignOutClick(self):
        self.lbl_user_name_surname.setText("")
        self.lbl_img_user.setPixmap(QPixmap(':/icon/images/user1.png'))

    def UserRegisterClick(self):
        print("Sign Register'a tıklandı")

    def retranslateUi(self, Form):
        _translate = QtCore.QCoreApplication.translate
        self.setStyleSheet("Background-color:white; border:none;")
        self.setWindowTitle(" ")
        self.setWindowIcon(QIcon(':/icon/images/transparent.png'))

        self.setFixedSize(QSize(250, 290))

    def setupUi(self, Form):
        Form.setObjectName("Form")
        self.setWindowFlags(QtCore.Qt.FramelessWindowHint | QtCore.Qt.Popup)

        layout = QVBoxLayout()
        self.lbl_img_user.setPixmap(QPixmap(':/icon/images/user1.png'))
        self.lbl_img_user.setScaledContents(True)
        self.lbl_img_user.setFixedWidth(170)
        self.lbl_img_user.setFixedHeight(115)

        self.btn_register.setFixedHeight(40)
        self.btn_signIn.setFixedHeight(40)
        self.btn_signOut.setFixedHeight(40)
        self.btn_register.setCursor(QtGui.QCursor(QtCore.Qt.PointingHandCursor))
        self.btn_signIn.setCursor(QtGui.QCursor(QtCore.Qt.PointingHandCursor))
        self.btn_signOut.setCursor(QtGui.QCursor(QtCore.Qt.PointingHandCursor))

        self.lbl_user_name_surname.setAlignment(Qt.AlignCenter)
        self.lbl_user_name_surname.setGeometry(105, 0, 25, 190)
        self.lbl_user_name_surname.setStyleSheet(
            "background-color:transparent; font-size: 14px; color:#a6a6a6;font-weight: bold;")

        btn_style = "color:white; border: 1px solid; border-color: rgb(255, 255, 255); border-radius: 8px 8px 8px 8px;"
        self.btn_register.setStyleSheet(
            "QPushButton { background-color: #F48FB1;" + btn_style + "} QPushButton:pressed { background-color: "
                                                                     "#EC407A; } ")
        self.btn_signIn.setStyleSheet(
            "QPushButton { background-color: #E1BEE7; " + btn_style + "} QPushButton:pressed { background-color: "
                                                                      "#AB47BC; }")
        self.btn_signOut.setStyleSheet(
            "QPushButton { background-color: #5C6BC0; " + btn_style + "} QPushButton:pressed { background-color: "
                                                                      "#303F9F; }")
        self.lbl_user_account.setStyleSheet("color:grey")

        layout.addWidget(self.lbl_img_user, alignment=Qt.AlignCenter)
        layout.addWidget(self.lbl_user_account, alignment=Qt.AlignCenter)
        layout.addWidget(self.btn_register)
        layout.addWidget(self.btn_signIn)
        layout.addWidget(self.btn_signOut)
        self.setLayout(layout)

