import icons_rc
from PyQt5 import QtCore, QtGui, QtWidgets
from PyQt5.QtWidgets import QDesktopWidget
from PyQt5.QtGui import *
import sys
import os
import json
from configuration import Configuration
from PyQt5.QtWidgets import *
from Components.StartPage.uc_sp_recentitem import UcSpRecentItem
from Components.StartPage.uc_sp_menuitem import UcSpMenuItem
from widgets import MessageBox
from Components.StartPage.recentmanager import RecentManager
from Components.StartPage.startmenumager import StartMenuManager
from pynar import MainWindow

import webbrowser

class StartPage(QWidget):
    def __init__(self, parent=None):
        super().__init__()

        self.c = Configuration()
        self.mainWindow = parent
        self.setupUi(self)
        self.center()
        self.rm = RecentManager()
        self.loadRecents()
        self.loadRightMenu()



    def setupUi(self, startpage_container):
        startpage_container.setObjectName("StartPage")
        startpage_container.resize(900, 630)

        self.gridLayout = QtWidgets.QGridLayout(startpage_container)
        self.gridLayout.setObjectName("gridLayout")
        self.pnl_header = QtWidgets.QFrame(startpage_container)
        self.pnl_header.setMaximumSize(QtCore.QSize(16777215, 100))
        self.pnl_header.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.pnl_header.setFrameShadow(QtWidgets.QFrame.Raised)
        self.pnl_header.setObjectName("pnlHeader")
        self.horizontalLayout_2 = QtWidgets.QHBoxLayout(self.pnl_header)
        self.horizontalLayout_2.setSpacing(15)
        self.horizontalLayout_2.setObjectName("horizontalLayout_2")
        self.lbl_icon_header = QtWidgets.QLabel(self.pnl_header)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Minimum, QtWidgets.QSizePolicy.Minimum)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.lbl_icon_header.sizePolicy().hasHeightForWidth())
        self.lbl_icon_header.setSizePolicy(sizePolicy)
        self.lbl_icon_header.setMaximumSize(QtCore.QSize(80, 80))
        self.lbl_icon_header.setText("")
        self.lbl_icon_header.setPixmap(QtGui.QPixmap(":/icon/images/headerLogo1.png"))
        self.lbl_icon_header.setScaledContents(True)
        self.lbl_icon_header.setObjectName("lblIconHeader")
        self.horizontalLayout_2.addWidget(self.lbl_icon_header)
        self.lbl_title_header = QtWidgets.QLabel(self.pnl_header)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Minimum, QtWidgets.QSizePolicy.Minimum)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.lbl_title_header.sizePolicy().hasHeightForWidth())
        self.lbl_title_header.setSizePolicy(sizePolicy)
        self.lbl_title_header.setMaximumSize(QtCore.QSize(16777215, 60))
        font = QtGui.QFont()
        font.setFamily("Segoe UI")
        font.setPointSize(30)
        font.setBold(True)
        font.setWeight(75)
        self.lbl_title_header.setFont(font)
        self.lbl_title_header.setObjectName("lblTitleHeader")
        self.horizontalLayout_2.addWidget(self.lbl_title_header)
        self.horizontalLayout_2.setStretch(0, 1)
        self.horizontalLayout_2.setStretch(1, 9)
        self.gridLayout.addWidget(self.pnl_header, 0, 0, 1, 1)
        self.pnl_content = QtWidgets.QFrame(startpage_container)
        self.pnl_content.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.pnl_content.setFrameShadow(QtWidgets.QFrame.Raised)
        self.pnl_content.setObjectName("pnlContent")
        self.horizontalLayout = QtWidgets.QHBoxLayout(self.pnl_content)
        self.horizontalLayout.setContentsMargins(0, 0, 0, 0)
        self.horizontalLayout.setObjectName("horizontalLayout")
        self.pnl_recents = QtWidgets.QFrame(self.pnl_content)
        self.pnl_recents.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.pnl_recents.setFrameShadow(QtWidgets.QFrame.Raised)
        self.pnl_recents.setObjectName("pnlRecents")
        self.verticalLayout_3 = QtWidgets.QVBoxLayout(self.pnl_recents)
        self.verticalLayout_3.setObjectName("verticalLayout_3")
        self.lbl_title_recent = QtWidgets.QLabel(self.pnl_recents)
        self.lbl_title_recent.setMaximumSize(QtCore.QSize(16777215, 30))
        font = QtGui.QFont()
        font.setFamily("Segoe UI")
        font.setPointSize(15)
        font.setBold(True)
        font.setWeight(75)
        self.lbl_title_recent.setFont(font)
        self.lbl_title_recent.setObjectName("lblTitleRecent")
        self.verticalLayout_3.addWidget(self.lbl_title_recent)
        self.lw_recent = QtWidgets.QListWidget(self.pnl_recents)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Preferred, QtWidgets.QSizePolicy.Preferred)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.lw_recent.sizePolicy().hasHeightForWidth())
        self.lw_recent.setSizePolicy(sizePolicy)
        self.lw_recent.setFrameShape(QtWidgets.QFrame.NoFrame)
        self.lw_recent.setObjectName("lwRecent")
        self.lw_recent.itemClicked.connect(self.onClickRecentItem)
        self.verticalLayout_3.addWidget(self.lw_recent)
        self.horizontalLayout.addWidget(self.pnl_recents)
        self.pnl_right_menu = QtWidgets.QFrame(self.pnl_content)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Minimum, QtWidgets.QSizePolicy.Minimum)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.pnl_right_menu.sizePolicy().hasHeightForWidth())
        self.pnl_right_menu.setSizePolicy(sizePolicy)
        self.pnl_right_menu.setMinimumSize(QtCore.QSize(400, 0))
        self.pnl_right_menu.setMaximumSize(QtCore.QSize(400, 16777215))
        self.pnl_right_menu.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.pnl_right_menu.setFrameShadow(QtWidgets.QFrame.Raised)
        self.pnl_right_menu.setObjectName("pnlRightMenu")
        self.verticalLayout = QtWidgets.QVBoxLayout(self.pnl_right_menu)
        self.verticalLayout.setObjectName("verticalLayout")
        self.lbl_title_menu = QtWidgets.QLabel(self.pnl_right_menu)
        self.lbl_title_menu.setMaximumSize(QtCore.QSize(16777215, 30))
        font = QtGui.QFont()
        font.setFamily("Segoe UI")
        font.setPointSize(15)
        font.setBold(True)
        font.setWeight(75)
        self.lbl_title_menu.setFont(font)
        self.lbl_title_menu.setObjectName("lblTitleMenu")
        self.verticalLayout.addWidget(self.lbl_title_menu)
        self.lw_menu = QtWidgets.QListWidget(self.pnl_right_menu)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Preferred, QtWidgets.QSizePolicy.Preferred)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.lw_menu.sizePolicy().hasHeightForWidth())
        self.lw_menu.setSizePolicy(sizePolicy)
        self.lw_menu.itemClicked.connect(self.onClickMenuItem)
        self.lw_menu.setFrameShape(QtWidgets.QFrame.NoFrame)
        self.lw_menu.setObjectName("lwMenu")
        self.verticalLayout.addWidget(self.lw_menu)
        self.horizontalLayout.addWidget(self.pnl_right_menu)
        self.horizontalLayout.setStretch(0, 4)
        self.horizontalLayout.setStretch(1, 3)
        self.gridLayout.addWidget(self.pnl_content, 1, 0, 1, 1)

        self.retranslateUi(startpage_container)
        QtCore.QMetaObject.connectSlotsByName(startpage_container)

    def retranslateUi(self, startpage_container):
        _translate = QtCore.QCoreApplication.translate
        startpage_container.setWindowTitle(_translate("StartPage", "PyNar Kod Editörü"))
        startpage_container.setWindowIcon(QIcon(':/icon/images/headerLogo1.png'))
        self.lbl_title_header.setText(_translate("StartPage", "PyNar\'a Hoşgeldiniz!"))
        self.lbl_title_recent.setText(_translate("StartPage", "Son Kullanılan Dosyalar"))
        self.lbl_title_menu.setText(_translate("StartPage", "Kullanmaya Başlayın"))

    # Recent dosyasındaki listeyi ekranda görüntüler
    def loadRecents(self):
        self.rm.removeAllItemNotExist()
        try:
                self.lw_recent.clear()
                self.c = Configuration()
                jsonFile = self.c.getHomeDir()+self.c.getJsonPath("recentJson")

                if not os.path.exists(jsonFile):
                    self.rm.createRecentJson()

                with open(jsonFile) as json_file:
                        data = json.load(json_file)

                        for p in data['files']:
                                recentItem = UcSpRecentItem(self)
                                recentItem.setValue(p['filename'],p['filepath'],p['opendate'])

                                item = QListWidgetItem(self.lw_recent)
                                item.setData(QtCore.Qt.UserRole,p)
                                item.setSizeHint(recentItem.sizeHint())
                                self.lw_recent.addItem(item)
                                self.lw_recent.setItemWidget(item, recentItem)
        except Exception as err:
                print("error: {0}".format(err))

    # Sağ menü listesi ekranda görüntüler
    def loadRightMenu(self):
        sm = StartMenuManager()
        for menuItem in sm.menus:
            btn = UcSpMenuItem(self)
            btn.setValue(menuItem.MenuName, menuItem.MenuDesc, menuItem.MenuIcon)
            item1 = QListWidgetItem(self.lw_menu)
            item1.setData(QtCore.Qt.UserRole, menuItem.MenuCode)
            item1.setSizeHint(btn.sizeHint())
            self.lw_menu.addItem(item1)
            self.lw_menu.setItemWidget(item1, btn)

    #  Recent listesindeki itemlara tıklanma olayı
    def onClickRecentItem(self, item):
        p = item.data(QtCore.Qt.UserRole)
        path = str(p['filepath'])
        if os.path.exists(path):
            self.mainWindow.open(starter=1, getPath=path)
            self.mainWindow.show()
            self.hide()
        else:
            q = MessageBox(QMessageBox.Warning, 'Uyarı',
                           'Dosya bulunamadı\n\nSon kullanılan dosyalar listesinden çıkarmak ister misiniz ?',
                           QMessageBox.Yes | QMessageBox.No)

            if (q.exec_() == QMessageBox.Yes):
                if self.rm.removeItem(path):
                    self.loadRecents()




    # sağ menu butonların tıklama olaylarını yönetir.
    def onClickMenuItem(self,item):
        p = item.data(QtCore.Qt.UserRole)
        if p == "example":
            if(self.mainWindow.saveAsExample()):
                self.mainWindow.show()
                self.hide()

        elif p == "new":
            self.mainWindow.new()
            self.mainWindow.show()
            self.hide()

        elif p == "open":
            filePath = self.c.getHomeDir()
            if(self.mainWindow.open(starter=None, getPath=filePath)):
                self.mainWindow.show()
                self.hide()

        elif p == "help":
            path = self.c.getHomeDir() + self.c.getHtmlHelpPath("html_help_path") + "PyNarKilavuz" + os.sep + "index.html"
            newTabOnWeb = 1
            webbrowser.open(path, new=newTabOnWeb)

        elif p == "skip":
            self.mainWindow.show()
            self.hide()

    def center(self):
        screen = QDesktopWidget().screenGeometry()
        size = self.geometry()
        self.move((screen.width() - size.width()) // 2, (screen.height() - size.height()) // 2)

