import sys
import os
import platform
import uuid

from PyQt5 import QtWidgets, QtCore
from PyQt5.uic.properties import QtGui

plt = platform.system()
from PyQt5.QtCore import QSize
from Components.LoginProcesses.login import UserLabel
import icons_rc
from PyQt5.QtWidgets import (QApplication, QMainWindow, QWidget, QHBoxLayout, QToolBar, QAction, QSplitter, QFileDialog,
                             QStatusBar, QDialog, QSizePolicy, QPushButton, QLineEdit, QDesktopWidget, QShortcut,
                             QProxyStyle, QStyle, QSpacerItem, QMessageBox)
from PyQt5.QtGui import QIcon, QPixmap
from PyQt5.Qt import Qt
from PyQt5.QtPrintSupport import QPrintDialog
from PyQt5.Qsci import QsciPrinter
from PyQt5 import QtGui
from pathlib import Path

from codeeditor import CodeEditor
from tabwidget import TabWidget
from codeview import CodeView
from runthread import RunThread
from configuration import Configuration
from dialog import SettingsDialog, EnterDialog, HelpDialog
from Components.ChatBotView.chatbotview import UcChatBotView
from Components.LeftMenu.Menus.uc_lm_menus import UcLMMenus
from Components.StartPage.recentmanager import RecentManager
from Components.LoginProcesses.login import LoginWindow
from Components.FindReplace.findreplacedialog import FindReplaceDialog														  
# from pyqt5_material import apply_stylesheet
from configuration import Configuration
activePage = None

#########MSTF
# Log icin su anki zaman gerekli
from datetime import datetime
import json
from PyQt5.QtGui import QKeySequence

file_to_write = ""
main_pointer = None

def generate_system_id():
    mac_address = uuid.getnode()
    system_id = (mac_address & 0xffffffffff)
    return system_id

def initialize_log():
    c = Configuration()
    global file_to_write
    time = datetime.now()
    timestamp = time.strftime('%Y_%m_%d-%H_%M_%S.%f')[:-3]
    data_folder = os.path.dirname(os.path.realpath(__file__))
    data_folder = Path(data_folder)
    # data_folder = data_folder / "log"
    data_folder = data_folder / c.getLogFolder()
    try:
        data_folder.mkdir(parents=True, exist_ok=False)
    except Exception as err:
        pass
    file_to_write = data_folder / (str(generate_system_id()) + "-" + str(timestamp) + ".json")


# CodeEditor Overwrite
class CodeEditor(CodeEditor):
    def __init__(self, parent=None):
        super().__init__(parent)

    def paste(self):
        super().paste()
        logfunc("Yapıştır: " + QApplication.clipboard().text())

    def keyPressEvent(self, event):
        super().keyPressEvent(event)
        if (event.key() == Qt.Key_Tab):
            key_pressed = "TAB"
        elif (event.key() == Qt.Key_Enter or event.key() == Qt.Key_Return):
            key_pressed = "ENTER"
        elif (event.key() == Qt.Key_Alt):
            key_pressed = "ALT"
        elif (event.key() == Qt.Key_Home):
            key_pressed = "HOME"
        elif (event.key() == Qt.Key_Insert):
            key_pressed = "INSERT"
        elif (event.key() == Qt.Key_End):
            key_pressed = "END"
        elif (event.key() == Qt.Key_Delete):
            key_pressed = "DELETE"
        elif (event.key() == Qt.Key_Control):
            key_pressed = "CTRL"
        elif (event.key() == Qt.Key_Up):
            key_pressed = "UP"
        elif (event.key() == Qt.Key_Down):
            key_pressed = "DOWN"
        elif (event.key() == Qt.Key_Left):
            key_pressed = "LEFT"
        elif (event.key() == Qt.Key_Right):
            key_pressed = "RIGHT"
        elif (event.key() == Qt.Key_Escape):
            key_pressed = "ESC"
        elif (event.key() == Qt.Key_Backspace):
            key_pressed = "BCKSPC"
        else:
            key_pressed = event.text()
        MOD_MASK = (Qt.CTRL | Qt.ALT | Qt.META)
        modifiers = int(event.modifiers())
        if (
                modifiers and modifiers & MOD_MASK == modifiers and event.key() > 0 and event.key() != Qt.Key_Shift and event.key() != Qt.Key_Alt and event.key() != Qt.Key_Control and event.key() != Qt.Key_Meta):
            key_pressed = QKeySequence(modifiers + event.key()).toString()
        # Tus kombinasyonlarinda modifier tusu logda gozukmesin
        if (key_pressed == "Ctrl+V"):
            logfunc("Yapıştır: " + QApplication.clipboard().text())
            return
        if (
                event.key() != Qt.Key_Shift and event.key() != Qt.Key_Alt and event.key() != Qt.Key_Control and event.key() != Qt.Key_Meta):
            logfunc("Basılan Tuş: " + key_pressed)

    # Sürükleme log
    def dropEvent(self, event):
        super().dropEvent(event)
        message = "Sürükle: " + event.mimeData().text()
        logfunc(message)
        
    def messenger(self, string):
        logfunc(string)


# Solmenü override
class UcLMMenus(UcLMMenus):
    def __init__(self, parent=None):
        super().__init__(parent)

    def MenuActionClick(self, jsonFile, index):
        super().MenuActionClick(jsonFile, index)
        message = self.toolButtons[index].text()
        message = "Solmenü_Tıkla: " + message.replace("\n", "")
        logfunc(message)


# QAction Overwrite
class QAction(QAction):
    def __init__(self, a=None, b=None, parent=None):
        if parent:
            super().__init__(a, b, parent)
        elif b:
            super().__init__(b, parent)
        elif a:
            super().__init__(parent)
        # QAction her çalıştığında logfunction fonksiyonunu çalıştır
        self.triggered.connect(self.log_action)

    # Çalıştırılan QAction'ı log dosyasına kaydet.
    def log_action(self, extra=""):
        if (self.sender().text() == "Aç"):
            return
        message = "Eylem: " + self.sender().text()
        logfunc(message)

# Loga yazma fonksiyonu
def logfunc(input_message, filestr=""):
    if (main_pointer.notebook.textPad == None):
        return
    c = Configuration()
    if (c.getLogEnabled() != "True"):
        return
    text_size = len(main_pointer.notebook.textPad.text())
    line_count = main_pointer.notebook.textPad.lines()
    time = datetime.now()
    timestamp = time.strftime('%Y_%m_%d %H-%M-%S.%f')[:-3]
    message = {'time': timestamp, 'action': input_message, 'totalchars': text_size, 'totallines': line_count}
    if (filestr != ""):
        message['file'] = filestr
    checker = True
    if (not os.path.exists(file_to_write)):
        checker = False
        with open(file_to_write, 'w', encoding='utf-8') as file:
            file.write("[\n]")
    with open(file_to_write, 'rb+') as file:
        file.seek(0, 2)
        size = file.tell()
        file.truncate(size - 1)
    with open(file_to_write, "a+", encoding='utf-8') as file:
        if checker:
            file.write(',\n')
        json.dump(message, file, ensure_ascii=False, indent=4)
        file.write(']')


#######################

class MainWindow(QMainWindow):

    def __init__(self):
        super().__init__()
        self.loginWindow = None
        self.c = Configuration()
        # self.setObjectName("mainWidget")
        path = os.path.abspath(__file__)
        # self.HOME = os.path.dirname(path) + '/'
        self.setWindowIcon(QIcon(':/icon/images/headerLogo1.png'))

        # change to Home Path
        home = str(os.chdir(Path.home()))

        # MSTF: LOG baslat, mainwindow pointeri ata
        initialize_log()
        global main_pointer
        main_pointer = self
        #
        # self.fileBrowser = None
        self.initUI(self)
        self.centerOnScreen()

        helpAction = QAction(self)
        helpAction.setShortcut('F1')
        helpAction.triggered.connect(self.help)

        self.addAction(helpAction)
        self.rm = RecentManager()

    def UserLoginClick(self):
        if self.loginWindow is None:
            self.loginWindow = LoginWindow(self)

        self.loginWindow.move(self.x() + (self.lbl_img_user.width()*(self.width()/self.lbl_img_user.width()))-self.loginWindow.width(),self.y()+self.lbl_img_user.height()*2)
        self.loginWindow.show()


    def initUI(self, MainWindow):

        self.header = QtWidgets.QMenuBar(MainWindow)
        self.header.setFixedHeight(100)
        self.header.setStyleSheet("""
            QMenuBar {background-color: #394b58; border: none;}
            QMenuBar::item {background-color: #394b58;}
            QMenu {icon-size: 80px;}
            QMenu::item {background: transparent;}
        """)
        self.header.setObjectName("header")
        MainWindow.setMenuBar(self.header)
        self.hBoxLayout= QtWidgets.QHBoxLayout(self.header)

        self.hBoxLayout.setObjectName("hBoxLayout")

        self.lbl_img_logo = QtWidgets.QLabel(self.header)
        self.lbl_img_logo.setMaximumSize(QtCore.QSize(85, 85))
        self.lbl_img_logo.setMinimumSize(QtCore.QSize(85, 85))
        self.lbl_img_logo.setPixmap(QPixmap(':/icon/images/headerLogo1.png'))
        self.lbl_img_logo.setScaledContents(True)
        self.lbl_img_logo.setFixedWidth(85)
        self.hBoxLayout.addWidget(self.lbl_img_logo)


        self.lbl_img_text = QtWidgets.QLabel(self.header)
        self.lbl_img_text.setMaximumSize(QtCore.QSize(100, 60))
        self.lbl_img_text.setMinimumSize(QtCore.QSize(100, 60))
        self.lbl_img_text.setPixmap(QPixmap(':/icon/images/headerLogo2.png'))
        self.lbl_img_text.setScaledContents(True)
        self.lbl_img_text.setFixedWidth(85)
        self.hBoxLayout.addWidget(self.lbl_img_text)

        verticalSpacer = QSpacerItem(1470, 40, QSizePolicy.Expanding, QSizePolicy.Expanding)
        self.hBoxLayout.addItem(verticalSpacer)

        self.lbl_img_user = UserLabel(self.header)
        self.lbl_img_user.setMaximumSize(QtCore.QSize(100, 60))
        self.lbl_img_user.setMinimumSize(QtCore.QSize(100, 60))
        self.lbl_img_user.setPixmap(QPixmap(':/icon/images/user.png'))
        self.lbl_img_user.setScaledContents(True)
        self.lbl_img_user.setFixedWidth(85)
        self.lbl_img_user.setCursor(QtGui.QCursor(QtCore.Qt.PointingHandCursor))
        self.hBoxLayout.addWidget(self.lbl_img_user)
        self.lbl_img_user.clicked.connect(self.UserLoginClick)

        MainWindow.resize(1600, 900)
        MainWindow.setMinimumSize(QtCore.QSize(1200, 700))


        self.setWindowTitle('PyNar Kod Editörü')

        self.splitter = QSplitter(Qt.Horizontal)

        # widgets
        self.notebook = TabWidget(self)
        self.codeView = CodeView(self, self.notebook)



        self.menus = UcLMMenus(self.notebook)
        self.menus.solGenislik(self.menus)

        self.chatbotview = UcChatBotView(self)
        self.chatbotview.setFixedWidth(335)
        self.notebook.newTab(codeView=self.codeView)
        self.textPad = self.notebook.textPad


        self.splitter.addWidget(self.menus)
        self.splitter.addWidget(self.notebook)
        self.splitter.addWidget(self.chatbotview)
        self.splitter.setStyleSheet("border:none")
        self.splitter.handle(1).setEnabled(False)
        self.splitter.handle(2).setEnabled(False)

        hbox = QHBoxLayout()
        hbox.addWidget(self.splitter)

        self.splitter.setStretchFactor(1, 10)

        self.setCentralWidget(self.splitter)

        
        # actions
        self.newAction = QAction(QIcon(':/icon/images/addfile.png'), 'Yeni', self)

        self.newAction.setShortcut('Ctrl+N')
        self.newAction.triggered.connect(self.new)

        self.openAction = QAction(QIcon(':/icon/images/openfile.png'), 'Aç', self)
        self.openAction.setShortcut('Ctrl+O')
        self.openAction.triggered.connect(self.open)

        self.saveAction = QAction(QIcon(':/icon/images/savefile.png'), 'Kaydet', self)
        self.saveAction.setShortcut('Ctrl+S')
        self.saveAction.triggered.connect(self.save)

        self.saveAsAction = QAction(QIcon(':/icon/images/save_as.png'), 'Farklı Kaydet', self)
        self.saveAsAction.setShortcut('Ctrl+Shift+S')
        self.saveAsAction.triggered.connect(self.saveAs)

        self.printAction = QAction(QIcon(':/icon/images/printicon.png'), 'Yazdır', self)
        self.printAction.setShortcut('Ctrl+P')
        self.printAction.triggered.connect(self.onPrint)

        self.undoAction = QAction(QIcon(':/icon/images/undo_i.png'), 'Geri Al', self)
        self.undoAction.setShortcut('Ctrl+Z')
        self.undoAction.triggered.connect(self.undo)

        self.redoAction = QAction(QIcon(':/icon/images/redo_i.png'), 'İleri Al', self)
        self.redoAction.setShortcut('Ctrl+Shift+Z')
        self.redoAction.triggered.connect(self.redo)

        self.zoomInAction = QAction(QIcon(':/icon/images/zoom_in.png'), 'Yakınlaştır', self)
        self.zoomInAction.setShortcut('Ctrl++')
        self.zoomInAction.triggered.connect(self.zoomIn)

        self.zoomOutAction = QAction(QIcon(':/icon/images/zoom_out.png'), 'Uzaklaştır', self)
        self.zoomOutAction.setShortcut('Ctrl+-')
        self.zoomOutAction.triggered.connect(self.zoomOut)

        self.settingsAction = QAction(QIcon(':/icon/images/settings_i.png'), 'Ayarlar', self)
        self.settingsAction.setShortcut('F9')
        self.settingsAction.triggered.connect(self.showSettings)

        self.interpreterAction = QAction(QIcon(':/icon/images/pythonstart.png'), 'Python Yorumlayıcıyı Başlat', self)
        self.interpreterAction.setShortcut('F10')
        self.interpreterAction.triggered.connect(self.interpreter)

        self.terminalAction = QAction(QIcon(':/icon/images/command.png'), 'Terminal Başlat', self)
        self.terminalAction.setShortcut('F11')
        self.terminalAction.triggered.connect(self.terminal)

        self.runAction = QAction(QIcon(':/icon/images/run_i.png'), 'Çalıştır', self)
        self.runAction.setShortcut('F12')
        self.runAction.triggered.connect(self.run)

        self.findAction = QAction(QIcon(':/icon/images/search.png'), 'Bul & Değiştir', self)
        self.findAction.setShortcut('Ctrl+F')
        self.findAction.triggered.connect(self.onSearch)

        spacer = QWidget()
        spacer.setSizePolicy(QSizePolicy.Expanding, QSizePolicy.Expanding)

        # make toolbar
        self.toolbar = QToolBar()
        self.toolbar.setFixedHeight(50)
        self.toolbar.setIconSize(QSize(50, 50))
        self.toolbar.setObjectName("mainToolbar")
        self.toolbar.setMovable(False)
        self.toolbar.setContextMenuPolicy(Qt.PreventContextMenu)
        self.addToolBar(Qt.TopToolBarArea, self.toolbar)

        # Skip butonuna basıldığında toolbar menu butonlarını pasif eder.
        self.changeToolbarButtonActive(False)

        # self.toolbar.setIconSize(QSize(50, 50))
        # self.toolbar.addSeparator()
        self.toolbar.addAction(self.newAction)
        # self.toolbar.addSeparator()
        self.toolbar.addAction(self.openAction)
        # self.toolbar.addSeparator()
        self.toolbar.addAction(self.saveAction)
        # self.toolbar.addSeparator()
        self.toolbar.addAction(self.saveAsAction)
        # self.toolbar.addSeparator()
        self.toolbar.addAction(self.printAction)
        # self.toolbar.addSeparator()
        self.toolbar.addAction(self.undoAction)
        # self.toolbar.addSeparator()
        self.toolbar.addAction(self.redoAction)
        # self.toolbar.addSeparator()
        self.toolbar.addAction(self.zoomInAction)
        # self.toolbar.addSeparator()
        self.toolbar.addAction(self.zoomOutAction)
        # self.toolbar.addSeparator()
        self.toolbar.addAction(self.settingsAction)
        # self.toolbar.addSeparator()
        self.toolbar.addAction(self.findAction)

        self.toolbar.addWidget(spacer)
        self.toolbar.addAction(self.interpreterAction)
        # self.toolbar.addSeparator()
        self.toolbar.addAction(self.terminalAction)
        # self.toolbar.addSeparator()
        self.toolbar.addAction(self.runAction)

        # make statusbar
        self.statusBar = QStatusBar()
        self.statusBar.setMinimumHeight(30)
        self.statusBar.setObjectName("mainStatusBar")
        self.setStatusBar(self.statusBar)



    def changeToolbarButtonActive(self, activeState):
        self.saveAction.setEnabled(activeState)
        self.saveAsAction.setEnabled(activeState)
        self.printAction.setEnabled(activeState)
        self.undoAction.setEnabled(activeState)
        self.redoAction.setEnabled(activeState)
        self.zoomInAction.setEnabled(activeState)
        self.zoomOutAction.setEnabled(activeState)
        self.interpreterAction.setEnabled(activeState)
        self.terminalAction.setEnabled(activeState)
        self.runAction.setEnabled(activeState)
        self.findAction.setEnabled(activeState)


    def new(self):
        editor = CodeEditor(parent=self)
        editor.filename = None

        self.notebook.newTab(editor)

        x = self.notebook.count()
        index = x - 1

        self.notebook.setCurrentIndex(index)
        self.textPad = editor
        self.notebook.textPad = editor
        self.mainWindow = self.textPad.mainWindow
        self.changeToolbarButtonActive(True)

    def open(self,starter = None, getPath = None):
        dialog = QFileDialog(self)
        dialog.setViewMode(QFileDialog.List)
        if plt == "Windows":
            dialog.setDirectory(os.path.join(os.environ['USERPROFILE'] + "/Documents/"))
        elif plt == "Linux":
            dialog.setDirectory(os.path.join(os.environ['HOME'] + "/Documents/"))

        if starter :
            filePath = getPath
            filename = (filePath,"*")
        else:
            filename = dialog.getOpenFileName(self, "Aç")
        if filename[0]:
            filePath = filename[0]

            try:
                with open(filePath, 'r', encoding='utf8') as f:
                    text = f.read()

                editor = CodeEditor(self)
                editor.setText(text)
                editor.filename = filePath

                self.notebook.newTab(editor)
                x = self.notebook.count()  # number of tabs
                index = x - 1
                self.notebook.setCurrentIndex(index)

                tabName = os.path.basename(editor.filename)
                self.notebook.setTabText(x, tabName)
                # self.textPad = editor
                self.notebook.textPad = editor
                self.textPad = self.notebook.textPad

                self.rm.addItem(tabName,filePath)
                
                #MSTF: Log open action
                logfunc("Eylem: Aç", str(filePath))
                #
                
            except Exception as e:
                self.statusBar.showMessage(str(e), 3000)

            self.changeToolbarButtonActive(True)
            return True


    def save(self):
        filename = self.textPad.filename
        index = self.notebook.currentIndex()
        tabText = self.notebook.tabText(index)

        if not filename:
            self.saveAs()

        else:
            text = self.textPad.text()
            try:
                with open(filename, 'w',newline='', encoding='utf8') as file: # dosyaya boş satır eklemeyi önlemek için newline='' olarak atandı
                    file.write(text)
                    self.statusBar.showMessage(filename + " kaydedildi", 3000)

                    # remove '*' in tabText
                    fname = os.path.basename(filename)
                    self.notebook.setTabText(index, fname)

                    self.rm.addItem(fname, filename)

            except Exception as e:
                self.statusBar.showMessage(str(e), 3000)
                self.saveAs()

    def saveAs(self):
        dialog = QFileDialog(self)
        dialog.setViewMode(QFileDialog.List)

        if plt == "Windows":
            dialog.setDirectory(os.path.join(os.environ['USERPROFILE'] + "/Documents/"))
        elif plt == "Linux":
            dialog.setDirectory(os.path.join(os.environ['HOME'] + "/Documents/"))

        filename = dialog.getSaveFileName(self, "Kaydet", "", "Python scripts (*.py)")

        if filename[0]:
            fullpath = filename[0]
            text = self.textPad.text()
            try:
                with open(fullpath, 'w', newline='',
                          encoding='utf8') as file:  # dosyaya boş satır eklemeyi önlemek için newline='' olarak atandı
                    file.write(text)
                    self.statusBar.showMessage(fullpath + " kaydedildi", 3000)

                    # update all widgets

                    self.textPad.filename = fullpath
                    self.refresh(self.textPad)
                    # self.fileBrowser.refresh()
                    fname = os.path.basename(fullpath)
                    index = self.notebook.currentIndex()
                    self.notebook.setTabText(index, fname)

                    self.rm.addItem(fname, fullpath)
            except Exception as e:
                self.statusBar.showMessage(str(e), 3000)

        else:
            self.statusBar.showMessage('Dosya kayıt edilemedi !', 3000)

    def saveAsExample(self):
        dialog = QFileDialog(self)
        dialog.setViewMode(QFileDialog.List)
        if plt == "Windows":
            dialog.setDirectory(os.path.join(os.environ['USERPROFILE'] + "/Documents/"))
            self.logPath = os.path.abspath(os.path.dirname(os.environ['USERPROFILE'] + "/Documents/"))
        elif plt == "Linux":
            dialog.setDirectory(os.path.join(os.environ['HOME'] + "/Documents/"))
            self.logPath = os.path.abspath(os.path.dirname(os.environ['HOME'] + "/Documents/"))

        init_filename = os.path.join(self.logPath, "merhabadunya.py")
        saveList = dialog.getSaveFileName(self, "Kaydet", init_filename, "Python scripts (*.py)")
        self.text = """print("Merhaba Dünya")"""

        if saveList[0]:
            self.fullpath = saveList[0]

            try:
                with open(self.fullpath, 'w', newline='',
                          encoding='utf8') as file:  # dosyaya boş satır eklemeyi önlemek için newline='' olarak atandı
                    file.write(self.text)
                    self.statusBar.showMessage(self.fullpath + " kaydedildi", 3000)

                with open(self.fullpath, 'r', encoding='utf8') as f:
                    text = f.read()

                editor = CodeEditor(self)
                editor.setText(text)
                editor.filename = self.fullpath

                self.notebook.newTab(editor)
                x = self.notebook.count()  # number of tabs
                index = x - 1
                self.notebook.setCurrentIndex(index)

                tabName = os.path.basename(editor.filename)
                self.notebook.setTabText(x, tabName)
                # self.textPad = editor
                self.notebook.textPad = editor
                self.textPad = self.notebook.textPad

                self.rm.addItem(tabName, self.fullpath)
                self.changeToolbarButtonActive(True)
                return True


            except Exception as err:
                print(err)
                return False
        return False

    def onPrint(self):
        doc = QsciPrinter()
        dialog = QPrintDialog(doc, self)
        dialog.setWindowTitle('Print')

        if (dialog.exec_() == QDialog.Accepted):
            self.textPad.setPythonPrintStyle()
            try:
                doc.printRange(self.textPad)
            except Exception as e:
                print(str(e))

        else:
            return

        self.textPad.setPythonStyle()

    def undo(self):
        self.textPad.undo()

    def redo(self):
        self.textPad.redo()

    def zoomIn(self):
        self.textPad.zoomIn()

    def zoomOut(self):
        self.textPad.zoomOut()

    def showSettings(self):
        try:
            dialog = SettingsDialog(self, self.textPad)
            dialog.setModal(False)
            dialog.exec_()
        except Exception as err:
            print("error show settings: {0}".format(err))

    def interpreter(self):
        c = Configuration()
        system = c.getSystem()
        command = c.getInterpreter(system)

        thread = RunThread(command)
        thread.start()

    def terminal(self):
        c = Configuration()
        system = c.getSystem()
        command = c.getTerminal(system)

        thread = RunThread(command)
        thread.start()

    def run(self):
        self.save()
        c = Configuration()
        system = c.getSystem()
        command = c.getRun(system).format(self.textPad.filename)

        if not self.textPad.filename:
            self.statusBar.showMessage("Dosya adı olmadan çalıştırılamaz!", 3000)
            return

        thread = RunThread(command)
        thread.start()

    def onSearch(self):
      if not self.textPad:
        return
      dialog = FindReplaceDialog(self,self.textPad)
      dialog.exec_()

    def refresh(self, textPad=None):
        if not textPad:
            return

        self.textPad = textPad

        if not self.textPad.filename:
            self.setWindowTitle('PyNar Kod Editörü')
            return

        dir = os.path.dirname(self.textPad.filename)

        try:
            os.chdir(dir)
            self.setWindowTitle(self.textPad.filename)

        except Exception as e:
            self.statusBar.showMessage(str(e), 3000)

        # self.fileBrowser.refresh(dir)
        self.codeView.refresh()

    def centerOnScreen(self):
        screen = QDesktopWidget().screenGeometry()
        size = self.geometry()
        self.move((screen.width() - size.width()) // 2, (screen.height() - size.height()) // 2)


    def help(self):
        helpdialog = HelpDialog(self)
        helpdialog.exec_()


# if __name__ == '__main__':
    # app = QApplication(sys.argv)
    # # apply_stylesheet(app, theme='white_pynar_theme.xml', light_secondary=True)
    # main = MainWindow()
    # sys.exit(app.exec_())

